Index: drivers/filesystems/btrfs/btrfs.c
===================================================================
--- drivers/filesystems/btrfs/btrfs.c	(révision 75772)
+++ drivers/filesystems/btrfs/btrfs.c	(copie de travail)
@@ -2051,51 +1967,67 @@
                         return Status;
                     }
                 }
-                
+
                 fileref->fcb->Header.AllocationSize.QuadPart = 0;
                 fileref->fcb->Header.FileSize.QuadPart = 0;
                 fileref->fcb->Header.ValidDataLength.QuadPart = 0;
-                
+
                 if (FileObject) {
                     CC_FILE_SIZES ccfs;
-                    
+
                     ccfs.AllocationSize = fileref->fcb->Header.AllocationSize;
                     ccfs.FileSize = fileref->fcb->Header.FileSize;
                     ccfs.ValidDataLength = fileref->fcb->Header.ValidDataLength;
-                    
-                    CcSetFileSizes(FileObject, &ccfs);
+
+                    Status = STATUS_SUCCESS;
+
+                    _SEH2_TRY {
+                        CcSetFileSizes(FileObject, &ccfs);
+                    } _SEH2_EXCEPT (EXCEPTION_EXECUTE_HANDLER) {
+                        Status = _SEH2_GetExceptionCode();
+                    } _SEH2_END;
+
+                    if (!NT_SUCCESS(Status)) {
+                        ERR("CcSetFileSizes threw exception %08x\n", Status);
+                        ExReleaseResourceLite(fileref->fcb->Header.Resource);
+                        return Status;
+                    }
                 }
+
+                fileref->fcb->deleted = TRUE;
             }
-                
-            le = fileref->fcb->hardlinks.Flink;
-            while (le != &fileref->fcb->hardlinks) {
-                hardlink* hl = CONTAINING_RECORD(le, hardlink, list_entry);
-                
-                if (hl->parent == fileref->parent->fcb->inode && hl->index == fileref->index) {
-                    RemoveEntryList(&hl->list_entry);
-                    
-                    if (hl->name.Buffer)
-                        ExFreePool(hl->name.Buffer);
-                    
-                    if (hl->utf8.Buffer)
-                        ExFreePool(hl->utf8.Buffer);
-                    
-                    ExFreePool(hl);
-                    break;
+
+            if (fileref->dc) {
+                le = fileref->fcb->hardlinks.Flink;
+                while (le != &fileref->fcb->hardlinks) {
+                    hardlink* hl = CONTAINING_RECORD(le, hardlink, list_entry);
+
+                    if (hl->parent == fileref->parent->fcb->inode && hl->index == fileref->dc->index) {
+                        RemoveEntryList(&hl->list_entry);
+
+                        if (hl->name.Buffer)
+                            ExFreePool(hl->name.Buffer);
+
+                        if (hl->utf8.Buffer)
+                            ExFreePool(hl->utf8.Buffer);
+
+                        ExFreePool(hl);
+                        break;
+                    }
+
+                    le = le->Flink;
                 }
-                
-                le = le->Flink;
             }
-        } else { // subvolume
+        } else if (fileref->fcb->subvol->parent == fileref->parent->fcb->subvol->id) { // valid subvolume
             if (fileref->fcb->subvol->root_item.num_references > 1) {
                 fileref->fcb->subvol->root_item.num_references--;
-                
+
                 mark_fcb_dirty(fileref->fcb); // so ROOT_ITEM gets updated
             } else {
                 // FIXME - we need a lock here
-                
+
                 RemoveEntryList(&fileref->fcb->subvol->list_entry);
-                
+
                 InsertTailList(&fileref->fcb->Vcb->drop_roots, &fileref->fcb->subvol->list_entry);
             }
         }
@@ -2103,95 +2035,136 @@
         fileref->fcb->deleted = TRUE;
         mark_fcb_dirty(fileref->fcb);
     }
-    
+
     // remove dir_child from parent
-    
+
     if (fileref->dc) {
+        TRACE("delete file %.*S\n", fileref->dc->name.Length / sizeof(WCHAR), fileref->dc->name.Buffer);
+
         ExAcquireResourceExclusiveLite(&fileref->parent->fcb->nonpaged->dir_children_lock, TRUE);
         RemoveEntryList(&fileref->dc->list_entry_index);
-        remove_dir_child_from_hash_lists(fileref->parent->fcb, fileref->dc);
+
+        if (!fileref->fcb->ads)
+            remove_dir_child_from_hash_lists(fileref->parent->fcb, fileref->dc);
+
         ExReleaseResourceLite(&fileref->parent->fcb->nonpaged->dir_children_lock);
-        
-        ExFreePool(fileref->dc->utf8.Buffer);
+
+        if (!fileref->oldutf8.Buffer)
+            fileref->oldutf8 = fileref->dc->utf8;
+        else
+            ExFreePool(fileref->dc->utf8.Buffer);
+
+        utf8len = fileref->dc->utf8.Length;
+
+        fileref->oldindex = fileref->dc->index;
+
         ExFreePool(fileref->dc->name.Buffer);
         ExFreePool(fileref->dc->name_uc.Buffer);
         ExFreePool(fileref->dc);
-        
+
         fileref->dc = NULL;
     }
-    
+
     // update INODE_ITEM of parent
-    
-    TRACE("delete file %.*S\n", fileref->filepart.Length / sizeof(WCHAR), fileref->filepart.Buffer);
+
     ExAcquireResourceExclusiveLite(fileref->parent->fcb->Header.Resource, TRUE);
-    TRACE("fileref->parent->fcb->inode_item.st_size (inode %llx) was %llx\n", fileref->parent->fcb->inode, fileref->parent->fcb->inode_item.st_size);
-    fileref->parent->fcb->inode_item.st_size -= fileref->utf8.Length * 2;
-    TRACE("fileref->parent->fcb->inode_item.st_size (inode %llx) now %llx\n", fileref->parent->fcb->inode, fileref->parent->fcb->inode_item.st_size);
+
     fileref->parent->fcb->inode_item.transid = fileref->fcb->Vcb->superblock.generation;
     fileref->parent->fcb->inode_item.sequence++;
     fileref->parent->fcb->inode_item.st_ctime = now;
-    fileref->parent->fcb->inode_item.st_mtime = now;
+
+    if (!fileref->fcb->ads) {
+        TRACE("fileref->parent->fcb->inode_item.st_size (inode %llx) was %llx\n", fileref->parent->fcb->inode, fileref->parent->fcb->inode_item.st_size);
+        fileref->parent->fcb->inode_item.st_size -= utf8len * 2;
+        TRACE("fileref->parent->fcb->inode_item.st_size (inode %llx) now %llx\n", fileref->parent->fcb->inode, fileref->parent->fcb->inode_item.st_size);
+        fileref->parent->fcb->inode_item.st_mtime = now;
+    }
+
+    fileref->parent->fcb->inode_item_changed = TRUE;
     ExReleaseResourceLite(fileref->parent->fcb->Header.Resource);
 
-    fileref->parent->fcb->inode_item_changed = TRUE;
+    if (!fileref->fcb->ads && fileref->parent->dc)
+        send_notification_fcb(fileref->parent, FILE_NOTIFY_CHANGE_LAST_WRITE, FILE_ACTION_MODIFIED, NULL);
+
     mark_fcb_dirty(fileref->parent->fcb);
-    
-    send_notification_fcb(fileref->parent, FILE_NOTIFY_CHANGE_LAST_WRITE, FILE_ACTION_MODIFIED);
-    
+
     fileref->fcb->subvol->root_item.ctransid = fileref->fcb->Vcb->superblock.generation;
     fileref->fcb->subvol->root_item.ctime = now;
-    
+
     newlength.QuadPart = 0;
-    
+
     if (FileObject && !CcUninitializeCacheMap(FileObject, &newlength, NULL))
         TRACE("CcUninitializeCacheMap failed\n");
 
     ExReleaseResourceLite(fileref->fcb->Header.Resource);
-    
+
     return STATUS_SUCCESS;
 }
 
-static NTSTATUS STDCALL drv_cleanup(IN PDEVICE_OBJECT DeviceObject, IN PIRP Irp) {
+_Dispatch_type_(IRP_MJ_CLEANUP)
+_Function_class_(DRIVER_DISPATCH)
+static NTSTATUS drv_cleanup(_In_ PDEVICE_OBJECT DeviceObject, _In_ PIRP Irp) {
     NTSTATUS Status;
     PIO_STACK_LOCATION IrpSp = IoGetCurrentIrpStackLocation(Irp);
     PFILE_OBJECT FileObject = IrpSp->FileObject;
     device_extension* Vcb = DeviceObject->DeviceExtension;
-    fcb* fcb;
+    fcb* fcb = FileObject->FsContext;
     BOOL top_level;
 
-    TRACE("cleanup\n");
-    
     FsRtlEnterFileSystem();
 
+    TRACE("cleanup\n");
+
     top_level = is_top_level(Irp);
-    
-    if (Vcb && Vcb->type == VCB_TYPE_PARTITION0) {
-        Status = part0_passthrough(DeviceObject, Irp);
-        goto exit2;
-    }
-    
-    if (DeviceObject == devobj) {
+
+    if (Vcb && Vcb->type == VCB_TYPE_VOLUME) {
+        Status = vol_cleanup(DeviceObject, Irp);
+        goto exit;
+    } else if (DeviceObject == master_devobj) {
         TRACE("closing file system\n");
         Status = STATUS_SUCCESS;
         goto exit;
+    } else if (!Vcb || Vcb->type != VCB_TYPE_FS) {
+        Status = STATUS_INVALID_PARAMETER;
+        goto exit;
     }
-    
+
+    if (FileObject->Flags & FO_CLEANUP_COMPLETE) {
+        TRACE("FileObject %p already cleaned up\n", FileObject);
+        Status = STATUS_SUCCESS;
+        goto exit;
+    }
+
+    if (!fcb) {
+        ERR("fcb was NULL\n");
+        Status = STATUS_INVALID_PARAMETER;
+        goto exit;
+    }
+
+    // We have to use the pointer to Vcb stored in the fcb, as we can receive cleanup
+    // messages belonging to other devices.
+
     if (FileObject && FileObject->FsContext) {
         LONG oc;
         ccb* ccb;
         file_ref* fileref;
-        
-        fcb = FileObject->FsContext;
+        BOOL locked = TRUE;
+
         ccb = FileObject->FsContext2;
         fileref = ccb ? ccb->fileref : NULL;
-        
+
         TRACE("cleanup called for FileObject %p\n", FileObject);
         TRACE("fileref %p (%S), refcount = %u, open_count = %u\n", fileref, file_desc(FileObject), fileref ? fileref->refcount : 0, fileref ? fileref->open_count : 0);
-        
+
+        ExAcquireResourceSharedLite(&fcb->Vcb->tree_lock, TRUE);
+
+        ExAcquireResourceExclusiveLite(fcb->Header.Resource, TRUE);
+
         IoRemoveShareAccess(FileObject, &fcb->share_access);
-        
-        FsRtlNotifyCleanup(Vcb->NotifySync, &Vcb->DirNotifyList, ccb);    
-        
+
+        if (ccb)
+            FsRtlNotifyCleanup(fcb->Vcb->NotifySync, &fcb->Vcb->DirNotifyList, ccb);
+
         if (fileref) {
             oc = InterlockedDecrement(&fileref->open_count);
 #ifdef DEBUG_FCB_REFCOUNTS
@@ -2198,49 +2171,64 @@
             ERR("fileref %p: open_count now %i\n", fileref, oc);
 #endif
         }
-        
+
         if (ccb && ccb->options & FILE_DELETE_ON_CLOSE && fileref)
             fileref->delete_on_close = TRUE;
-        
-        if (fileref && fileref->delete_on_close && fcb->type == BTRFS_TYPE_DIRECTORY && fcb->inode_item.st_size > 0)
+
+        if (fileref && fileref->delete_on_close && fcb->type == BTRFS_TYPE_DIRECTORY && fcb->inode_item.st_size > 0 && fcb != fcb->Vcb->dummy_fcb)
             fileref->delete_on_close = FALSE;
-        
-        if (Vcb->locked && Vcb->locked_fileobj == FileObject) {
+
+        if (fcb->Vcb->locked && fcb->Vcb->locked_fileobj == FileObject) {
             TRACE("unlocking volume\n");
-            do_unlock_volume(Vcb);
+            do_unlock_volume(fcb->Vcb);
             FsRtlNotifyVolumeEvent(FileObject, FSRTL_VOLUME_UNLOCK);
         }
-        
+
+        if (ccb && ccb->reserving) {
+            fcb->subvol->reserved = NULL;
+            ccb->reserving = FALSE;
+            // FIXME - flush all of subvol's fcbs
+        }
+
         if (fileref && oc == 0) {
-            if (!Vcb->removing) {
-                LIST_ENTRY rollback;
-        
-                InitializeListHead(&rollback);
-            
+            if (!fcb->Vcb->removing) {
                 if (fileref && fileref->delete_on_close && fileref != fcb->Vcb->root_fileref && fcb != fcb->Vcb->volume_fcb) {
-                    send_notification_fileref(fileref, fcb->type == BTRFS_TYPE_DIRECTORY ? FILE_NOTIFY_CHANGE_DIR_NAME : FILE_NOTIFY_CHANGE_FILE_NAME, FILE_ACTION_REMOVED);
-                    
-                    ExAcquireResourceSharedLite(&fcb->Vcb->tree_lock, TRUE);
-                    
+                    LIST_ENTRY rollback;
+
+                    InitializeListHead(&rollback);
+
+                    if (!fileref->fcb->ads || fileref->dc) {
+                        if (fileref->fcb->ads) {
+                            send_notification_fileref(fileref->parent, fcb->type == BTRFS_TYPE_DIRECTORY ? FILE_NOTIFY_CHANGE_DIR_NAME : FILE_NOTIFY_CHANGE_FILE_NAME,
+                                                      FILE_ACTION_REMOVED, &fileref->dc->name);
+                        } else
+                            send_notification_fileref(fileref, fcb->type == BTRFS_TYPE_DIRECTORY ? FILE_NOTIFY_CHANGE_DIR_NAME : FILE_NOTIFY_CHANGE_FILE_NAME, FILE_ACTION_REMOVED, NULL);
+                    }
+
+                    ExReleaseResourceLite(fcb->Header.Resource);
+                    locked = FALSE;
+
+                    // fcb_lock needs to be acquired before fcb->Header.Resource
                     ExAcquireResourceExclusiveLite(&fcb->Vcb->fcb_lock, TRUE);
-                    
+
                     Status = delete_fileref(fileref, FileObject, Irp, &rollback);
                     if (!NT_SUCCESS(Status)) {
                         ERR("delete_fileref returned %08x\n", Status);
-                        do_rollback(Vcb, &rollback);
+                        do_rollback(fcb->Vcb, &rollback);
                         ExReleaseResourceLite(&fcb->Vcb->fcb_lock);
                         ExReleaseResourceLite(&fcb->Vcb->tree_lock);
                         goto exit;
                     }
-                    
+
                     ExReleaseResourceLite(&fcb->Vcb->fcb_lock);
-                    
-                    ExReleaseResourceLite(&fcb->Vcb->tree_lock);
-                    clear_rollback(Vcb, &rollback);
+
+                    locked = FALSE;
+
+                    clear_rollback(&rollback);
                 } else if (FileObject->Flags & FO_CACHE_SUPPORTED && fcb->nonpaged->segment_object.DataSectionObject) {
                     IO_STATUS_BLOCK iosb;
                     CcFlushCache(FileObject->SectionObjectPointer, NULL, 0, &iosb);
-                    
+
                     if (!NT_SUCCESS(iosb.Status)) {
                         ERR("CcFlushCache returned %08x\n", iosb.Status);
                     }
@@ -2251,37 +2239,44 @@
                     }
 
                     CcPurgeCacheSection(&fcb->nonpaged->segment_object, NULL, 0, FALSE);
-                    
+
                     TRACE("flushed cache on close (FileObject = %p, fcb = %p, AllocationSize = %llx, FileSize = %llx, ValidDataLength = %llx)\n",
                         FileObject, fcb, fcb->Header.AllocationSize.QuadPart, fcb->Header.FileSize.QuadPart, fcb->Header.ValidDataLength.QuadPart);
                 }
             }
-            
+
             if (fcb->Vcb && fcb != fcb->Vcb->volume_fcb)
                 CcUninitializeCacheMap(FileObject, NULL, NULL);
         }
-        
+
+        if (locked)
+            ExReleaseResourceLite(fcb->Header.Resource);
+
+        ExReleaseResourceLite(&fcb->Vcb->tree_lock);
+
         FileObject->Flags |= FO_CLEANUP_COMPLETE;
     }
-    
+
     Status = STATUS_SUCCESS;
 
 exit:
+    TRACE("returning %08x\n", Status);
+
     Irp->IoStatus.Status = Status;
     Irp->IoStatus.Information = 0;
-    
+
     IoCompleteRequest(Irp, IO_NO_INCREMENT);
-    
-exit2:
-    if (top_level) 
+
+    if (top_level)
         IoSetTopLevelIrp(NULL);
-    
+
     FsRtlExitFileSystem();
 
     return Status;
 }
 
-BOOL get_file_attributes_from_xattr(char* val, UINT16 len, ULONG* atts) {
+_Success_(return)
+BOOL get_file_attributes_from_xattr(_In_reads_bytes_(len) char* val, _In_ UINT16 len, _Out_ ULONG* atts) {
     if (len > 2 && val[0] == '0' && val[1] == 'x') {
         int i;
         ULONG dosnum = 0;
@@ -2288,7 +2283,7 @@
 
         for (i = 2; i < len; i++) {
             dosnum *= 0x10;
-            
+
             if (val[i] >= '0' && val[i] <= '9')
                 dosnum |= val[i] - '0';
             else if (val[i] >= 'a' && val[i] <= 'f')
@@ -2296,35 +2291,37 @@
             else if (val[i] >= 'A' && val[i] <= 'F')
                 dosnum |= val[i] + 10 - 'a';
         }
-        
+
         TRACE("DOSATTRIB: %08x\n", dosnum);
-        
+
         *atts = dosnum;
-        
+
         return TRUE;
     }
-    
+
     return FALSE;
 }
 
-ULONG STDCALL get_file_attributes(device_extension* Vcb, INODE_ITEM* ii, root* r, UINT64 inode, UINT8 type, BOOL dotfile, BOOL ignore_xa, PIRP Irp) {
+ULONG get_file_attributes(_In_ _Requires_lock_held_(_Curr_->tree_lock) device_extension* Vcb, _In_ root* r, _In_ UINT64 inode,
+                          _In_ UINT8 type, _In_ BOOL dotfile, _In_ BOOL ignore_xa, _In_opt_ PIRP Irp) {
     ULONG att;
     char* eaval;
     UINT16 ealen;
-    
-    // ii can be NULL
-    
+
     if (!ignore_xa && get_xattr(Vcb, r, inode, EA_DOSATTRIB, EA_DOSATTRIB_HASH, (UINT8**)&eaval, &ealen, Irp)) {
         ULONG dosnum = 0;
-        
+
         if (get_file_attributes_from_xattr(eaval, ealen, &dosnum)) {
             ExFreePool(eaval);
-            
+
             if (type == BTRFS_TYPE_DIRECTORY)
                 dosnum |= FILE_ATTRIBUTE_DIRECTORY;
             else if (type == BTRFS_TYPE_SYMLINK)
                 dosnum |= FILE_ATTRIBUTE_REPARSE_POINT;
-            
+
+            if (type != BTRFS_TYPE_DIRECTORY)
+                dosnum &= ~FILE_ATTRIBUTE_DIRECTORY;
+
             if (inode == SUBVOL_ROOT_INODE) {
                 if (r->root_item.flags & BTRFS_SUBVOL_READONLY)
                     dosnum |= FILE_ATTRIBUTE_READONLY;
@@ -2331,33 +2328,33 @@
                 else
                     dosnum &= ~FILE_ATTRIBUTE_READONLY;
             }
-            
+
             return dosnum;
         }
-        
+
         ExFreePool(eaval);
     }
-    
+
     switch (type) {
         case BTRFS_TYPE_DIRECTORY:
             att = FILE_ATTRIBUTE_DIRECTORY;
             break;
-            
+
         case BTRFS_TYPE_SYMLINK:
             att = FILE_ATTRIBUTE_REPARSE_POINT;
             break;
-           
+
         default:
             att = 0;
             break;
     }
-    
+
     if (dotfile) {
         att |= FILE_ATTRIBUTE_HIDDEN;
     }
-    
+
     att |= FILE_ATTRIBUTE_ARCHIVE;
-    
+
     if (inode == SUBVOL_ROOT_INODE) {
         if (r->root_item.flags & BTRFS_SUBVOL_READONLY)
             att |= FILE_ATTRIBUTE_READONLY;
@@ -2364,137 +2361,137 @@
         else
             att &= ~FILE_ATTRIBUTE_READONLY;
     }
-    
+
     // FIXME - get READONLY from ii->st_mode
     // FIXME - return SYSTEM for block/char devices?
-    
+
     if (att == 0)
         att = FILE_ATTRIBUTE_NORMAL;
-    
+
     return att;
 }
 
-NTSTATUS sync_read_phys(PDEVICE_OBJECT DeviceObject, LONGLONG StartingOffset, ULONG Length, PUCHAR Buffer, BOOL override) {
-    IO_STATUS_BLOCK* IoStatus;
+NTSTATUS sync_read_phys(_In_ PDEVICE_OBJECT DeviceObject, _In_ UINT64 StartingOffset, _In_ ULONG Length,
+                        _Out_writes_bytes_(Length) PUCHAR Buffer, _In_ BOOL override) {
+    IO_STATUS_BLOCK IoStatus;
     LARGE_INTEGER Offset;
     PIRP Irp;
     PIO_STACK_LOCATION IrpSp;
     NTSTATUS Status;
-    read_context* context;
-    
+    read_context context;
+
     num_reads++;
-    
-    context = ExAllocatePoolWithTag(NonPagedPool, sizeof(read_context), ALLOC_TAG);
-    if (!context) {
-        ERR("out of memory\n");
-        return STATUS_INSUFFICIENT_RESOURCES;
-    }
-    
-    RtlZeroMemory(context, sizeof(read_context));
-    KeInitializeEvent(&context->Event, NotificationEvent, FALSE);
-    
-    IoStatus = ExAllocatePoolWithTag(NonPagedPool, sizeof(IO_STATUS_BLOCK), ALLOC_TAG);
-    if (!IoStatus) {
-        ERR("out of memory\n");
-        ExFreePool(context);
-        return STATUS_INSUFFICIENT_RESOURCES;
-    }
 
-    Offset.QuadPart = StartingOffset;
+    RtlZeroMemory(&context, sizeof(read_context));
+    KeInitializeEvent(&context.Event, NotificationEvent, FALSE);
 
-//     Irp = IoBuildSynchronousFsdRequest(IRP_MJ_READ, DeviceObject, Buffer, Length, &Offset, /*&Event*/NULL, IoStatus);
+    Offset.QuadPart = (LONGLONG)StartingOffset;
+
     Irp = IoAllocateIrp(DeviceObject->StackSize, FALSE);
-    
+
     if (!Irp) {
         ERR("IoAllocateIrp failed\n");
-        Status = STATUS_INSUFFICIENT_RESOURCES;
-        goto exit;
+        return STATUS_INSUFFICIENT_RESOURCES;
     }
-    
+
     Irp->Flags |= IRP_NOCACHE;
     IrpSp = IoGetNextIrpStackLocation(Irp);
     IrpSp->MajorFunction = IRP_MJ_READ;
-    
+
     if (override)
         IrpSp->Flags |= SL_OVERRIDE_VERIFY_VOLUME;
-    
+
     if (DeviceObject->Flags & DO_BUFFERED_IO) {
-        FIXME("FIXME - buffered IO\n");
+        Irp->AssociatedIrp.SystemBuffer = ExAllocatePoolWithTag(NonPagedPool, Length, ALLOC_TAG);
+        if (!Irp->AssociatedIrp.SystemBuffer) {
+            ERR("out of memory\n");
+            Status = STATUS_INSUFFICIENT_RESOURCES;
+            goto exit;
+        }
+
+        Irp->Flags |= IRP_BUFFERED_IO | IRP_DEALLOCATE_BUFFER | IRP_INPUT_OPERATION;
+
+        Irp->UserBuffer = Buffer;
     } else if (DeviceObject->Flags & DO_DIRECT_IO) {
-//         TRACE("direct IO\n");
-        
         Irp->MdlAddress = IoAllocateMdl(Buffer, Length, FALSE, FALSE, NULL);
         if (!Irp->MdlAddress) {
             ERR("IoAllocateMdl failed\n");
             Status = STATUS_INSUFFICIENT_RESOURCES;
-    //         IoFreeIrp(Irp);
             goto exit;
-//         } else {
-//             TRACE("got MDL %p from buffer %p\n", Irp->MdlAddress, Buffer);
         }
-        
-        MmProbeAndLockPages(Irp->MdlAddress, KernelMode, IoWriteAccess);
-    } else {
-//         TRACE("neither buffered nor direct IO\n");
+
+        Status = STATUS_SUCCESS;
+
+        _SEH2_TRY {
+            MmProbeAndLockPages(Irp->MdlAddress, KernelMode, IoWriteAccess);
+        } _SEH2_EXCEPT (EXCEPTION_EXECUTE_HANDLER) {
+            Status = _SEH2_GetExceptionCode();
+        } _SEH2_END;
+
+        if (!NT_SUCCESS(Status)) {
+            ERR("MmProbeAndLockPages threw exception %08x\n", Status);
+            IoFreeMdl(Irp->MdlAddress);
+            goto exit;
+        }
+    } else
         Irp->UserBuffer = Buffer;
-    }
 
     IrpSp->Parameters.Read.Length = Length;
     IrpSp->Parameters.Read.ByteOffset = Offset;
-    
-    Irp->UserIosb = IoStatus;
-//     Irp->Tail.Overlay.Thread = PsGetCurrentThread();
-    
-    Irp->UserEvent = &context->Event;
 
-//     IoQueueThreadIrp(Irp);
-    
-    IoSetCompletionRoutine(Irp, read_completion, context, TRUE, TRUE, TRUE);
+    Irp->UserIosb = &IoStatus;
 
+    Irp->UserEvent = &context.Event;
+
+    IoSetCompletionRoutine(Irp, read_completion, &context, TRUE, TRUE, TRUE);
+
     Status = IoCallDriver(DeviceObject, Irp);
 
     if (Status == STATUS_PENDING) {
-        KeWaitForSingleObject(&context->Event, Executive, KernelMode, FALSE, NULL);
-        Status = context->iosb.Status;
+        KeWaitForSingleObject(&context.Event, Executive, KernelMode, FALSE, NULL);
+        Status = context.iosb.Status;
     }
-    
+
     if (DeviceObject->Flags & DO_DIRECT_IO) {
         MmUnlockPages(Irp->MdlAddress);
         IoFreeMdl(Irp->MdlAddress);
     }
-    
+
 exit:
     IoFreeIrp(Irp);
 
-    ExFreePool(IoStatus);
-    ExFreePool(context);
-    
     return Status;
 }
 
-static NTSTATUS STDCALL read_superblock(device_extension* Vcb, PDEVICE_OBJECT device, UINT64 length) {
+static NTSTATUS read_superblock(_In_ device_extension* Vcb, _In_ PDEVICE_OBJECT device, _In_ UINT64 length) {
     NTSTATUS Status;
     superblock* sb;
-    unsigned int i, to_read;
+    ULONG i, to_read;
     UINT8 valid_superblocks;
-    
-    to_read = device->SectorSize == 0 ? sizeof(superblock) : sector_align(sizeof(superblock), device->SectorSize);
-    
+
+    to_read = device->SectorSize == 0 ? sizeof(superblock) : (ULONG)sector_align(sizeof(superblock), device->SectorSize);
+
     sb = ExAllocatePoolWithTag(NonPagedPool, to_read, ALLOC_TAG);
     if (!sb) {
         ERR("out of memory\n");
         return STATUS_INSUFFICIENT_RESOURCES;
     }
-    
+
+    if (superblock_addrs[0] + to_read > length) {
+        WARN("device was too short to have any superblock\n");
+        ExFreePool(sb);
+        return STATUS_UNRECOGNIZED_VOLUME;
+    }
+
     i = 0;
     valid_superblocks = 0;
-    
+
     while (superblock_addrs[i] > 0) {
         UINT32 crc32;
-        
-        if (i > 0 && superblock_addrs[i] + sizeof(superblock) > length)
+
+        if (i > 0 && superblock_addrs[i] + to_read > length)
             break;
-        
+
         Status = sync_read_phys(device, superblock_addrs[i], to_read, (PUCHAR)sb, FALSE);
         if (!NT_SUCCESS(Status)) {
             ERR("Failed to read superblock %u: %08x\n", i, Status);
@@ -2501,47 +2498,53 @@
             ExFreePool(sb);
             return Status;
         }
-        
+
         if (sb->magic != BTRFS_MAGIC) {
             if (i == 0) {
                 TRACE("not a BTRFS volume\n");
+                ExFreePool(sb);
                 return STATUS_UNRECOGNIZED_VOLUME;
             }
         } else {
             TRACE("got superblock %u!\n", i);
-            
+
             crc32 = ~calc_crc32c(0xffffffff, (UINT8*)&sb->uuid, (ULONG)sizeof(superblock) - sizeof(sb->checksum));
-            
+
             if (crc32 != *((UINT32*)sb->checksum))
                 WARN("crc32 was %08x, expected %08x\n", crc32, *((UINT32*)sb->checksum));
+            else if (sb->sector_size == 0)
+                WARN("superblock sector size was 0\n");
+            else if (sb->node_size < sizeof(tree_header) + sizeof(internal_node) || sb->node_size > 0x10000)
+                WARN("invalid node size %x\n", sb->node_size);
+            else if ((sb->node_size % sb->sector_size) != 0)
+                WARN("node size %x was not a multiple of sector_size %x\n", sb->node_size, sb->sector_size);
             else if (valid_superblocks == 0 || sb->generation > Vcb->superblock.generation) {
                 RtlCopyMemory(&Vcb->superblock, sb, sizeof(superblock));
                 valid_superblocks++;
             }
         }
-        
+
         i++;
     }
-    
+
     ExFreePool(sb);
-    
+
     if (valid_superblocks == 0) {
         ERR("could not find any valid superblocks\n");
         return STATUS_INTERNAL_ERROR;
     }
-    
+
     TRACE("label is %s\n", Vcb->superblock.label);
-    
+
     return STATUS_SUCCESS;
 }
 
-NTSTATUS STDCALL dev_ioctl(PDEVICE_OBJECT DeviceObject, ULONG ControlCode, PVOID InputBuffer, ULONG InputBufferSize,
-                           PVOID OutputBuffer, ULONG OutputBufferSize, BOOLEAN Override, IO_STATUS_BLOCK* iosb)
-{
+NTSTATUS dev_ioctl(_In_ PDEVICE_OBJECT DeviceObject, _In_ ULONG ControlCode, _In_reads_bytes_opt_(InputBufferSize) PVOID InputBuffer, _In_ ULONG InputBufferSize,
+                   _Out_writes_bytes_opt_(OutputBufferSize) PVOID OutputBuffer, _In_ ULONG OutputBufferSize, _In_ BOOLEAN Override, _Out_opt_ IO_STATUS_BLOCK* iosb) {
     PIRP Irp;
     KEVENT Event;
     NTSTATUS Status;
-    PIO_STACK_LOCATION Stack;
+    PIO_STACK_LOCATION IrpSp;
     IO_STATUS_BLOCK IoStatus;
 
     KeInitializeEvent(&Event, NotificationEvent, FALSE);
@@ -2559,8 +2562,8 @@
     if (!Irp) return STATUS_INSUFFICIENT_RESOURCES;
 
     if (Override) {
-        Stack = IoGetNextIrpStackLocation(Irp);
-        Stack->Flags |= SL_OVERRIDE_VERIFY_VOLUME;
+        IrpSp = IoGetNextIrpStackLocation(Irp);
+        IrpSp->Flags |= SL_OVERRIDE_VERIFY_VOLUME;
     }
 
     Status = IoCallDriver(DeviceObject, Irp);
@@ -2569,7 +2572,7 @@
         KeWaitForSingleObject(&Event, Executive, KernelMode, FALSE, NULL);
         Status = IoStatus.Status;
     }
-    
+
     if (iosb)
         *iosb = IoStatus;
 
@@ -2576,17 +2579,24 @@
     return Status;
 }
 
-static NTSTATUS STDCALL add_root(device_extension* Vcb, UINT64 id, UINT64 addr, traverse_ptr* tp) {
+_Requires_exclusive_lock_held_(Vcb->tree_lock)
+static NTSTATUS add_root(_Inout_ device_extension* Vcb, _In_ UINT64 id, _In_ UINT64 addr,
+                         _In_ UINT64 generation, _In_opt_ traverse_ptr* tp) {
     root* r = ExAllocatePoolWithTag(PagedPool, sizeof(root), ALLOC_TAG);
     if (!r) {
         ERR("out of memory\n");
         return STATUS_INSUFFICIENT_RESOURCES;
     }
-    
+
     r->id = id;
-    r->path.Buffer = NULL;
+    r->dirty = FALSE;
+    r->received = FALSE;
+    r->reserved = NULL;
     r->treeholder.address = addr;
     r->treeholder.tree = NULL;
+    r->treeholder.generation = generation;
+    r->parent = 0;
+    r->send_ops = 0;
     InitializeListHead(&r->fcbs);
 
     r->nonpaged = ExAllocatePoolWithTag(NonPagedPool, sizeof(root_nonpaged), ALLOC_TAG);
